'From Cuis 2.9 of 5 November 2010 [latest update: #634] on 3 December 2010 at 10:10:10 am'!

!BorderedSubpaneDividerMorph methodsFor: 'initialization' stamp: 'jmv 12/3/2010 10:04'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self extent: 1 @ 1! !


!CodeProvider methodsFor: 'annotation' stamp: 'jmv 12/1/2010 16:04'!
defaultButtonPaneHeight
	"Answer the user's preferred default height for new button panes."

	^Preferences standardButtonFont height * 14 // 8! !


!TestRunner methodsFor: 'constants' stamp: 'jmv 12/3/2010 09:41'!
refreshButtonState
	"Never 'pressed' from the model's point of view"
	^false! !

!TestRunner methodsFor: 'constants' stamp: 'jmv 12/3/2010 09:42'!
runButtonState
	"Appear 'presed' while running."
	^ running notNil! !

!TestRunner methodsFor: 'interface opening' stamp: 'jmv 11/29/2010 18:12'!
buildLowerPanes
	| failuresList errorsList column tHeight divider |
	column _ AlignmentMorph proportional.
	self buildPassFailText.
	self buildDetailsText.
	self buildTestsList.
	failuresList _ self buildFailuresList.
	errorsList _ self buildErrorsList.
	tHeight _ 26.
	divider _ Array new: 3.
	1
		to: divider size
		do: [:index | 
			divider at: index put: BorderedSubpaneDividerMorph forBottomEdge ].
	column
		addMorph: (passFailText borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ 0 corner: 0 @ tHeight - 1)).
	column
		addMorph: (divider at: 1)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (tHeight - 1) corner: 0 @ tHeight)).
	column
		addMorph: (detailsText borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ tHeight corner: 0 @ (2 * tHeight - 1))).
	column
		addMorph: (divider at: 2)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (2 * tHeight - 1) corner: 0 @ (2 * tHeight))).
	column
		addMorph: (failuresList borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 0.6)
				offsets: (0 @ (2 * tHeight) corner: 0 @ -1)).
	column
		addMorph: (divider at: 3)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.6 corner: 1 @ 0.6)
				offsets: (0 @ - 1 corner: 0 @ 0)).
	column
		addMorph: (errorsList borderWidth: 0)
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.6 corner: 1 @ 1)
				offsets: (0 @ 0 corner: 0 @ 0)).
	^ column! !

!TestRunner methodsFor: 'interface opening' stamp: 'jmv 12/3/2010 09:57'!
buildTestsList
	| column buttonRow bh |
	column _ AlignmentMorph proportional.
	testsList _ PluggableListMorphOfMany
				model: self
				listGetter: #tests
				primarySelectionGetter: #selectedSuite
				primarySelectionSetter: #selectedSuite:
				listSelectionGetter: #listSelectionAt:
				listSelectionSetter: #listSelectionAt:put:
				menuGetter: #listMenu:shifted:.
	testsList autoDeselect: false.
	testsList color: Color veryVeryLightGray.
	bh _ self defaultButtonPaneHeight.
	column
		addMorph: testsList
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (0@0 corner: 1 @ bh negated)).
	buttonRow _ self optionalButtonRow.
	column
		addMorph: buttonRow
		fullFrame: (LayoutFrame
				fractions: (0 @ 1 corner: 1 @ 1)
				offsets: (0@bh negated corner: 0@0)).
	^ column! !

!TestRunner methodsFor: 'interface opening' stamp: 'jmv 12/3/2010 09:55'!
buildUpperControls
	| refreshButton filterButton stopButton runOneButton runButton row bWidth listsMorph |
	row _ AlignmentMorph proportional.
	refreshButton _ self buildRefreshButton.
	filterButton _ self buildFilterButton.
	stopButton _ self buildStopButton.
	runOneButton _ self buildRunOneButton.
	runButton _ self buildRunButton.
	listsMorph _ self buildTestsList.
	bWidth _ 90.
	row
		addMorph: refreshButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 0 @ 0.33)
				offsets: (0 @ 0 corner: bWidth @ 0)).
	row
		addMorph: filterButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.33 corner: 0 @ 0.66)
				offsets: (0 @ 0 corner: bWidth @ 0)).
	row
		addMorph: stopButton
		fullFrame: (LayoutFrame
				fractions: (0 @ 0.66 corner: 0 @ 1)
				offsets: (0 @ 0 corner: bWidth @ 0)).
	row
		addMorph: listsMorph
		fullFrame: (LayoutFrame
				fractions: (0 @ 0 corner: 1 @ 1)
				offsets: (bWidth  @ 0 corner: bWidth negated @ 0)).
	row
		addMorph: runOneButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 0 corner: 1 @ 0.5)
				offsets: (bWidth negated @ 0 corner: 0 @ 0)).
	row
		addMorph: runButton
		fullFrame: (LayoutFrame
				fractions: (1 @ 0.5 corner: 1 @ 1)
				offsets: (bWidth negated @ 0 corner: -0 @ 0)).
	^ row! !

!TestRunner methodsFor: 'interface opening' stamp: 'jmv 12/3/2010 09:54'!
defaultButtonPaneHeight
	"Answer the user's preferred default height for new button panes."

	^Preferences standardButtonFont height * 2! !

!TestRunner methodsFor: 'interface opening' stamp: 'jmv 12/3/2010 10:08'!
morphicWindow
	"TestRunner new openAsMorph"
	| upperRow lowerPanes fracYRatio divider window |
	window _ SystemWindow labelled: self windowLabel.
	window model: self.
	upperRow _ self buildUpperControls.
	lowerPanes _ self buildLowerPanes.
	fracYRatio _ 0.25.
	window
		addMorph: upperRow
		fullFrame: (LayoutFrame fractions: (0 @ 0 extent: 1 @ fracYRatio)).
	divider _ BorderedSubpaneDividerMorph forBottomEdge.
	window
		addMorph: divider
		fullFrame: (LayoutFrame
				fractions: (0 @ fracYRatio corner: 1 @ fracYRatio)
				offsets: (0 @ 0 corner: 0 @ 2)).

	window
		addMorph: lowerPanes
		fullFrame: (LayoutFrame fractions: (0 @ fracYRatio extent: 1 @ (1 - fracYRatio))
		offsets: (0@2 corner: 0@0)).
	self refreshWindow.
	window extent: 460 @ 400.
	^window! !

!TestRunner methodsFor: 'menus' stamp: 'jmv 12/3/2010 09:58'!
optionalButtonTuples
	^#(
		#(20	'select all' 				#selectAll) 
		#(20	'deselect all' 			#deselectAll) 
		#(20	'toggle selections' 		#toggleSelections)
	)! !

BorderedSubpaneDividerMorph removeSelector: #defaultBorderWidth!
ArrayLiteralTest removeSelector: #array!
