'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 15 March 2011 at 9:52:58 am'!
!classDefinition: #SystemWindow category: #'Morphic-Windows'!
PluggableMorph subclass: #SystemWindow
	instanceVariableNames: 'labelString collapsedFrame fullFrame isCollapsed updatablePanes widgetsColor layoutMorph topAdjuster bottomAdjuster leftAdjuster rightAdjuster topLeftAdjuster bottomLeftAdjuster topRightAdjuster bottomRightAdjuster '
	classVariableNames: 'CloseIcon CollapseIcon ExpandIcon MenuIcon RoundedCornerBL RoundedCornerBR RoundedCornerTL RoundedCornerTR TitleGradient TopWindow RoundedCornerTLPlain RoundedCornerTRPlain '
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!MenuMorph methodsFor: 'drawing' stamp: 'jmv 3/15/2011 09:50'!
drawOn: aCanvas
	
	| roundCorners r c |
	roundCorners _ Theme current roundWindowCorners.
	roundCorners
		ifTrue: [
			c _ self fillStyle.
			r _ Theme current roundedWindowRadius.
			aCanvas image: SystemWindow roundedCornerBL multipliedBy: c at: bounds bottomLeft - (0@r).
			aCanvas image: SystemWindow roundedCornerBR multipliedBy: c at: bounds bottomRight - (r@r) .
			aCanvas image: SystemWindow roundedCornerTLPlain multipliedBy: c at: bounds topLeft.
			aCanvas image: SystemWindow roundedCornerTRPlain multipliedBy: c at: bounds topRight - (r@0).
			aCanvas fillRectangle: (bounds insetBy: (0 @ r corner: 0 @ r)) fillStyle: c.
			aCanvas fillRectangle: ((bounds bottomLeft + (r@r negated)) extent: (bounds width - r - r@r)) fillStyle: c.
			aCanvas fillRectangle: ((bounds withHeight: r) insetBy: r@0) color: c ]
		ifFalse: [
			super drawOn: aCanvas ].! !


!SystemWindow class methodsFor: 'accessing - forms' stamp: 'jmv 3/15/2011 09:45'!
roundedCornerTLPlain
	"
	RoundedCornerTL _ nil.
	Display getCanvas translucentImage: (self roundedCornerTL:20) at: 520@10
	"
	| f r  |
	r _ Theme current roundedWindowRadius.
	(RoundedCornerTLPlain notNil and: [
		RoundedCornerTLPlain width = r and: [ RoundedCornerTLPlain height = r ]]) ifFalse: [
		f _ Form
			topLeftCorner: r
			height: r
			gradientTop: 1.0
			gradientBottom: 1.0.
		RoundedCornerTLPlain _ f ].
	^ RoundedCornerTLPlain! !

!SystemWindow class methodsFor: 'accessing - forms' stamp: 'jmv 3/15/2011 09:45'!
roundedCornerTRPlain
	"
	RoundedCornerTR _ nil.
	Display getCanvas translucentImage: self roundedCornerTR at: 10@60
	"
	| f r |
	r _ Theme current roundedWindowRadius.
	(RoundedCornerTRPlain notNil and: [
		RoundedCornerTRPlain width = r and: [ RoundedCornerTRPlain height = r ]]) ifFalse: [
		f _ Form
			topRightCorner: r
			height: r
			gradientTop: 1.0
			gradientBottom: 1.0.
		RoundedCornerTRPlain _ f ].
	^ RoundedCornerTRPlain! !


!TheWorldMenu methodsFor: 'construction' stamp: 'jmv 3/15/2011 09:26'!
changesMenu
        "Build the changes menu for the world."

        | menu |
        menu _ self menu: 'changes...'.
        self fillIn: menu from: {
                { 'file out current change set' . { ChangeSet current . #verboseFileOut}.
                                'Write the current change set out to a file whose name reflects the change set name and the current date & time.'}.
                { 'create new change set...' . { ChangeSorter . #newChangeSet}. 'Create a new change set and make it the current one.'}.
                { 'check change set for slips' . { self  . #lookForSlips}.
                                'Check the current change set for halts, references to the Transcript, etc., and if any such thing is found, open up a message-list browser detailing all possible slips.'}.

                nil.
                { 'simple change sorter' . {self. #openChangeSorter1}.  'Open a 3-paned changed-set viewing tool'}.
                { 'dual change sorter' . {self. #openChangeSorter2}.
                                'Open a change sorter that shows you two change sets at a time, making it easy to copy and move methods and classes between them.'}.
                nil.
                { 'browse recent submissions' . { Utilities . #browseRecentSubmissions}.
                                'Open a new recent-submissions browser.  A recent-submissions browser is a message-list browser that shows the most recent methods that have been submitted.  If you submit changes within that browser, it will keep up-to-date, always showing the most recent submissions.'}.

                { 'find recent submissions' . { #myWorld . #openRecentSubmissionsBrowser:}.
                                'Make an open recent-submissions browser be the front-window, expanding a collapsed one or creating a new one if necessary.  A recent-submissions browser is a message-list browser that shows the most recent methods that have been submitted, latest first.  If you submit changes within that browser, it will keep up-to-date, always showing the most recent submissions at the top of the browser.'}.

			nil.
                { 'recently logged changes...' . { ChangeList . #browseRecentLog}.'Open a change-list browser on the latter part of the changes log.  You can use this browser to recover logged changes which were not saved in your image, in the event of a crash or other interruption.'}.

                { 'recent log file...' . { Smalltalk . #writeRecentToFile}.
                                'Create a file holding the logged changes (going as far back as you wish), and open a window on that file.'}.

                nil.
                { 'save world as morph file' . {self. #saveWorldInFile}. 'Save a file that, when reloaded, reconstitutes the current World.'}.
        }.
        ^ menu! !


!Theme methodsFor: 'menu colors' stamp: 'jmv 3/15/2011 09:22'!
menu
	Display depth <= 2 ifTrue: [^ Color white].
	^Color r: 0.7 g: 0.7 b: 0.7 alpha: 0.8! !

!classDefinition: #SystemWindow category: #'Morphic-Windows'!
PluggableMorph subclass: #SystemWindow
	instanceVariableNames: 'labelString collapsedFrame fullFrame isCollapsed updatablePanes widgetsColor layoutMorph topAdjuster bottomAdjuster leftAdjuster rightAdjuster topLeftAdjuster bottomLeftAdjuster topRightAdjuster bottomRightAdjuster'
	classVariableNames: 'CloseIcon CollapseIcon ExpandIcon MenuIcon RoundedCornerBL RoundedCornerBR RoundedCornerTL RoundedCornerTLPlain RoundedCornerTR RoundedCornerTRPlain TitleGradient TopWindow'
	poolDictionaries: ''
	category: 'Morphic-Windows'!
