'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 30 March 2011 at 9:25:33 am'!

!Character class methodsFor: 'class initialization' stamp: 'jmv 3/29/2011 08:34'!
initializeUnicodeCodePoints

	"Initialize the table of Unicode code points"
	UnicodeCodePoints _ Array new: 256.
	0 to: 255 do: [ :code |
		UnicodeCodePoints at: code + 1 put: code ].
	
	"The following codes are different in ISO 8859-15 from those in ISO 8859-1,
	so the character code is not equal to the Unicode code point"
	UnicodeCodePoints at: 16rA4+1 put: 16r20AC.		"euro sign"
	UnicodeCodePoints at: 16rA6+1 put: 16r160.		"latin capital letter S with caron"
	UnicodeCodePoints at: 16rA8+1 put: 16r161.		"latin small letter s with caron"
	UnicodeCodePoints at: 16rB4+1 put: 16r17D.		"latin capital letter Z with caron"
	UnicodeCodePoints at: 16rB8+1 put: 16r17E.		"latin small letter z with caron"
	UnicodeCodePoints at: 16rBC+1 put: 16r152.		"latin capital ligature OE"
	UnicodeCodePoints at: 16rBD+1 put: 16r153.		"latin small ligature oe"
	UnicodeCodePoints at: 16rBE+1 put: 16r178.		"latin capital letter Y with diaeresis"! !


!OrderedCollection methodsFor: 'removing' stamp: 'jmv 3/30/2011 08:56'!
removeAll

	array from: firstIndex to: lastIndex put: nil.
	lastIndex _ firstIndex - 1! !


!Rectangle class methodsFor: 'instance creation' stamp: 'jmv 3/30/2011 08:33'!
merging: listOfRects 
	"A number of callers of merge: should use this method.
	Note: ignore possible nils in the argument."
	| minX minY maxX maxY |
	listOfRects
		do: [ :r | 
			r ifNotNil: [
				minX
					ifNil: [
						minX _ r topLeft x. minY _ r topLeft y.
						maxX _ r bottomRight x. maxY _ r bottomRight y]
					ifNotNil: [
						minX _ minX min: r topLeft x. minY _ minY min: r topLeft y.
						maxX _ maxX max: r bottomRight x. maxY _ maxY max: r bottomRight y]]].
	^ minX@minY corner: maxX@maxY! !


!SystemWindow methodsFor: 'top window' stamp: 'jmv 3/29/2011 14:56'!
passivate
	"Make me unable to respond to mouse and keyboard"

	| focus |
	focus _ ActiveHand keyboardFocus.
	focus ifNotNil: [
		(focus ownerThatIsA: SystemWindow) == self
			ifTrue: [ ActiveHand releaseKeyboardFocus ]].

	model modelSleep.
	self redrawNeeded! !

