'From Cuis 3.1 of 4 March 2011 [latest update: #850] on 7 April 2011 at 11:02:05 am'!

!Browser methodsFor: 'initialize-release' stamp: 'jmv 4/7/2011 10:56'!
buildMorphicWindow
	"Create a pluggable version of all the morphs for a Browser in Morphic"

	| window upperPanes |
	upperPanes _ LayoutMorph newRow.
	upperPanes
		addMorph: self buildMorphicSystemCatList proportionalWidth: 0.2;
		addAdjusterAndMorph: self buildMorphicClassColumn proportionalWidth: 0.2;
		addAdjusterAndMorph: self buildMorphicMessageCatList proportionalWidth: 0.2;
		addAdjusterAndMorph: self buildMorphicMessageList proportionalWidth: 0.4.
	
	window _ SystemWindow new model: self.
	window layoutMorph
		addMorph: upperPanes proportionalHeight: 0.3;
		addAdjusterAndMorph: self buildLowerPanes proportionalHeight: 0.7.

	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	self changed: #editSelection.
	^ window! !

!Browser methodsFor: 'initialize-release' stamp: 'jmv 4/7/2011 10:57'!
buildNoSysCatMorphicWindow
	"A Browser without the class categories list"

	| window mySingletonList upperPanes |
	mySingletonList _ PluggableListMorph 
				model: self
				listGetter: #systemCategorySingleton
				indexGetter: #indexIsOne
				indexSetter: #indexIsOne:
				menuGetter: #systemCatSingletonMenu
				keystrokeAction: #systemCatSingletonKey:from:.
	mySingletonList enableDragNDrop: false.
	mySingletonList hideScrollBarsIndefinitely.

	upperPanes _ LayoutMorph newRow.
	upperPanes
		addMorph: self buildMorphicClassColumn proportionalWidth: 0.3;
		addAdjusterAndMorph: self buildMorphicMessageCatList proportionalWidth: 0.3;
		addAdjusterAndMorph: self buildMorphicMessageList proportionalWidth: 0.4.
	
	window _ SystemWindow new model: self.
	window layoutMorph
		addMorph: mySingletonList fixedHeight: Preferences standardCodeFont height + 10;
		addAdjusterAndMorph: upperPanes proportionalHeight: 0.3;
		addAdjusterAndMorph: self buildLowerPanes proportionalHeight: 0.7.

	window setUpdatablePanesFrom: #(classList messageCategoryList messageList).
	self changed: #editSelection.
	^ window! !


!FileContentsBrowser methodsFor: 'creation' stamp: 'jmv 4/7/2011 10:58'!
buildMorphicWindow
	"Create a pluggable version of all the views for a Browser, including views and controllers."

	| window list1 list2 upperPanes |
	contentsSymbol _ self defaultDiffsSymbol.  "#showDiffs or #prettyDiffs"
	window _ SystemWindow new model: self.
	self systemCategoryListIndex: 1.
	list1 _ PluggableListMorph 
			model: self 
			listGetter: #systemCategorySingleton
			indexGetter: #indexIsOne 
			indexSetter: #indexIsOne:
			menuGetter: #packageListMenu
			keystrokeAction: #packageListKey:from:.
	list1 hideScrollBarsIndefinitely.
	
	list2 _ PluggableListMorph 
			model: self 
			listGetter: #messageCategoryList
			indexGetter: #messageCategoryListIndex 
			indexSetter: #messageCategoryListIndex:
			menuGetter: #messageCategoryMenu.

	upperPanes _ LayoutMorph newRow.
	upperPanes
		addMorph: self buildMorphicClassColumn proportionalWidth: 0.3;
		addAdjusterAndMorph: list2 proportionalWidth: 0.3;
		addAdjusterAndMorph: self buildMorphicMessageList proportionalWidth: 0.4.

	window _ SystemWindow new model: self.
	window layoutMorph
		addMorph: list1 fixedHeight: Preferences standardCodeFont height + 10;
		addAdjusterAndMorph: upperPanes proportionalHeight: 0.3;
		addAdjusterAndMorph: self buildLowerPanes proportionalHeight: 0.7.
	self changed: #editSelection.
	^ window! !


!PackagePaneBrowser methodsFor: 'initialize-release' stamp: 'jmv 4/7/2011 10:59'!
buildMorphicWindow
	"Create a pluggable version of all the morphs for a Browser in Morphic"
	"PackagePaneBrowser openBrowser"

	| window upperPanes |
	upperPanes _ LayoutMorph newRow.
	upperPanes
		addMorph: self buildMorphicPackageList proportionalWidth: 0.2;
		addAdjusterAndMorph: self buildMorphicSystemCatList proportionalWidth: 0.15;
		addAdjusterAndMorph: self buildMorphicClassColumn proportionalWidth: 0.2;
		addAdjusterAndMorph: self buildMorphicMessageCatList proportionalWidth: 0.15;
		addAdjusterAndMorph: self buildMorphicMessageList proportionalWidth: 0.3.

	window _ SystemWindow new model: self.
	window layoutMorph
		addMorph: upperPanes proportionalHeight: 0.4;
		addAdjusterAndMorph: self buildLowerPanes proportionalHeight: 0.6.

	window setUpdatablePanesFrom: #(systemCategoryList classList messageCategoryList messageList).
	self changed: #editSelection.
	^ window! !


!RealEstateAgent class methodsFor: 'as yet unclassified' stamp: 'jmv 4/7/2011 10:54'!
standardWindowExtent
	"Answer the standard default extent for new windows.  "

	| effectiveExtent width strips height grid allowedArea maxLevel |
	effectiveExtent _ self maximumUsableArea extent
					- (self scrollBarSetback @ self screenTopSetback).
	Preferences reverseWindowStagger ifTrue:
		["NOTE: following copied from strictlyStaggeredInitialFrameFor:"
		allowedArea _ self maximumUsableArea insetBy: (
			self scrollBarSetback @ self screenTopSetback extent: 0@0
		).
		"Number to be staggered at each corner (less on small screens)"
		maxLevel _ allowedArea area > 700000 ifTrue: [3] ifFalse: [2].
		"Amount by which to stagger (less on small screens)"
		grid _ allowedArea area > 700000 ifTrue: [40] ifFalse: [20].
		^ (allowedArea extent - (grid*(maxLevel+1*2) + (grid//2))) min: 40@32 * Preferences standardCodeFont height ].
	width _ (strips _ self windowColumnsDesired) > 1
		ifTrue:
			[effectiveExtent x // strips]
		ifFalse:
			[(3 * effectiveExtent x) // 4].
	height _ (strips _ self windowRowsDesired) > 1
		ifTrue:
			[effectiveExtent y // strips]
		ifFalse:
			[(3 * effectiveExtent y) //4].
	^ width @ height

"RealEstateAgent standardWindowExtent"! !

WorldState class removeSelector: #classVersion!
SystemWindow class removeSelector: #classVersion!
