'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 20 April 2011 at 10:35:04 am'!
!classDefinition: #Taskbar category: #'Taskbar-Core'!
LayoutMorph subclass: #Taskbar
	instanceVariableNames: ''
	classVariableNames: 'SoleInstance'
	poolDictionaries: ''
	category: 'Taskbar-Core'!

!Taskbar commentStamp: '<historical>' prior: 0!
A simple task bar written for Cuis.!

!classDefinition: #TaskbarTask category: #'Taskbar-Core'!
Switch subclass: #TaskbarTask
	instanceVariableNames: 'morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Taskbar-Core'!

!TaskbarTask commentStamp: '<historical>' prior: 0!
I represent iconified windows on the Taskbar.!


!Taskbar methodsFor: 'change reporting' stamp: 'jmv 4/20/2011 10:34'!
step

	"My dimensions are constrained live."
	| r |
	r _ World bounds.
	self bounds: (r left @ (r bottom -18) extent: r width@18)! !

!Taskbar methodsFor: 'commands' stamp: 'cbr 4/18/2011 22:17'!
minimize: aMorph

	TaskbarTask new minimize: aMorph! !

!Taskbar methodsFor: 'commands' stamp: 'cbr 4/19/2011 02:15'!
restore: aMorph
	
	self submorphs do: [ :button |
		button model morph == aMorph
			ifTrue: [ aMorph visible: true ]]! !

!Taskbar methodsFor: 'commands' stamp: 'cbr 4/19/2011 00:03'!
restoreAll
	
	self submorphs do: [ :button | self restore: button model morph ]! !

!Taskbar methodsFor: 'initialization' stamp: 'cbr 4/19/2011 01:16'!
initialize

	super initialize.

	self
		color: Theme current menu;
		startStepping! !


!Taskbar class methodsFor: 'class initialization' stamp: 'cbr 4/19/2011 00:09'!
initialize

	self singleton openInWorld! !

!Taskbar class methodsFor: 'class initialization' stamp: 'cbr 4/18/2011 23:47'!
reset

	self singleton restoreAll.

	self singleton delete.

	SoleInstance _ nil! !

!Taskbar class methodsFor: 'commands' stamp: 'cbr 4/19/2011 02:17'!
hide

	self singleton visible: false! !

!Taskbar class methodsFor: 'commands' stamp: 'cbr 4/18/2011 20:20'!
minimize: aMorph

	self singleton minimize: aMorph! !

!Taskbar class methodsFor: 'commands' stamp: 'cbr 4/18/2011 19:57'!
restore: aMorph

	self singleton restore: aMorph! !

!Taskbar class methodsFor: 'commands' stamp: 'cbr 4/19/2011 00:17'!
show

	| taskbar | taskbar _ self singleton.
	
	taskbar visible: true.
	taskbar isInWorld ifFalse: [ taskbar openInWorld ]! !

!Taskbar class methodsFor: 'testing' stamp: 'cbr 4/18/2011 19:22'!
visible

	^ self singleton visible! !

!Taskbar class methodsFor: 'instance creation' stamp: 'cbr 4/18/2011 04:54'!
singleton

	^ SoleInstance ifNil: [ SoleInstance _ self newRow ]! !


!TaskbarTask methodsFor: 'accessing' stamp: 'cbr 4/18/2011 22:16'!
morph

	^ morph! !

!TaskbarTask methodsFor: 'commands' stamp: 'cbr 4/19/2011 00:38'!
minimize: aMorph

	| button label |

	morph _ aMorph.
	
	(morph respondsTo: #label) 
		ifTrue: [ label _ morph label ] 
		ifFalse: [ label _ morph class name ].

	self turnOn.

	button _ PluggableButtonMorph
			model: self
			stateGetter: nil
			action: #switch
			label: label.
	
	button
		layoutSpec: (LayoutSpec proportionalWidth: 1);	
		borderColor: #raised;
		borderWidth: 2;
		color: Taskbar singleton color.

	Taskbar singleton addMorph: button.
			
	morph visible: false! !

!TaskbarTask methodsFor: 'commands' stamp: 'cbr 4/19/2011 02:18'!
restore: aMorph
	
	morph expand.
	aMorph visible: true.
	
	Taskbar singleton submorphs do: [ :button |
		button model == self ifTrue: [ Taskbar singleton removeMorph: button ]
	]! !

!TaskbarTask methodsFor: 'state' stamp: 'cbr 4/19/2011 18:24'!
switch

	self flag: #todo. "Does the model really need to be a switch? I don't think so..."
	super switch.
	self restore: morph! !

Taskbar initialize!
