'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 19 April 2011 at 6:26:17 pm'!
!classDefinition: #TaskbarTaskTest category: #'Taskbar-Tests'!
TestCase subclass: #TaskbarTaskTest
	instanceVariableNames: 'task morph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Taskbar-Tests'!
!classDefinition: #TaskbarTest category: #'Taskbar-Tests'!
TestCase subclass: #TaskbarTest
	instanceVariableNames: 'taskbar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Taskbar-Tests'!

!TaskbarTest commentStamp: '<historical>' prior: 0!
Tests for the Taskbar.!


!TaskbarTask methodsFor: 'state' stamp: 'cbr 4/19/2011 18:24'!
switch

	self flag: #todo. "Does the model really need to be a switch? I don't think so..."
	super switch.
	self restore: morph! !


!TaskbarTaskTest methodsFor: 'as yet unclassified' stamp: 'cbr 4/19/2011 18:18'!
setUp

	morph _ Morph new.
	task _ TaskbarTask new minimize: morph! !

!TaskbarTaskTest methodsFor: 'as yet unclassified' stamp: 'cbr 4/19/2011 18:22'!
testMinimize

	task restore: morph.
	task minimize: morph.
	self shouldnt: [ morph visible ]! !

!TaskbarTaskTest methodsFor: 'as yet unclassified' stamp: 'cbr 4/19/2011 18:23'!
testMorph
	self should: [ task respondsTo: #morph ]! !

!TaskbarTaskTest methodsFor: 'as yet unclassified' stamp: 'cbr 4/19/2011 18:20'!
testRestore

	task restore: morph.
	self should: [ morph visible ]! !


!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 03:05'!
testClassHide

	taskbar class hide.
	self shouldnt: [ taskbar visible ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 03:07'!
testClassMinimize

	| m | m _ Morph new.

	taskbar class minimize: m.
	self shouldnt: [ m visible ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 03:11'!
testClassReset

	| a b |
	a _ Morph new.
	b _ Morph new. 

	taskbar
		minimize: a;
		minimize: b.
		
	taskbar class reset.

	self shouldnt: [ a isInWorld & b isInWorld ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 03:16'!
testClassRestore

	| m | m _ Morph new. 

	taskbar minimize: m.
	
	self should: [ m visible not ].

	taskbar class restore: m.

	self should: [ m visible ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 18:12'!
testClassShow
	taskbar class show.
	self should: [ taskbar isInWorld ].
	World removeMorph: taskbar! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 18:13'!
testClassSingleton

	self should: [ taskbar == taskbar class singleton ].
! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 18:13'!
testClassVisible

	self should: [ taskbar visible = taskbar class visible ].
! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:55'!
testHeight
	
	self should: [ taskbar height = 18 ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:56'!
testHorizontalAlignment
	
	self should: [ taskbar left = World left ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:48'!
testMinimize

	|m| m _ Morph new. 
	taskbar minimize: m.
	self shouldnt: [ m visible ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:48'!
testRestore

	|m| m _ Morph new. 
	taskbar minimize: m.
	taskbar restore: m.
	self should: [ m visible ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:54'!
testRestoreAll

	| a b |
	a _ Morph new.
	b _ Morph new. 

	taskbar
		minimize: a;
		minimize: b;
		restoreAll.

	self should: [ a visible & b visible ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:54'!
testVerticalAlignment
	
	self should: [ taskbar bottom = World bottom ]! !

!TaskbarTest methodsFor: 'test cases' stamp: 'cbr 4/19/2011 02:54'!
testWidth
	
	self should: [ taskbar width = World width ]
! !

!TaskbarTest methodsFor: 'Running' stamp: 'cbr 4/18/2011 17:35'!
setUp

	Taskbar reset.	
	taskbar := Taskbar singleton.
	taskbar visible: false.
	taskbar step.! !

TaskbarTest class removeSelector: #testFoo!

!TaskbarTest reorganize!
('test cases' testClassHide testClassMinimize testClassReset testClassRestore testClassShow testClassSingleton testClassVisible testHeight testHorizontalAlignment testMinimize testRestore testRestoreAll testVerticalAlignment testWidth)
('Running' setUp)
!

TaskbarTaskTest removeSelector: #testTaskRestore!
TaskbarTask class removeSelector: #testFoo!
