'From Cuis 3.2 of 12 April 2011 [latest update: #914] on 30 May 2011 at 8:40:24 am'!

!LightWidget methodsFor: 'events-processing' stamp: 'jmv 5/28/2011 00:37'!
handlerForMouseDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event"
	anEvent mouseButton3Pressed ifTrue:[^self handlerForMouseButton3Down: anEvent].
	(self handlesMouseDown: anEvent) ifFalse:[^nil]. "not interested"
	anEvent handler ifNil:[^self]. "Nobody else was interested"
	self mouseDownPriority >= anEvent handler mouseDownPriority 
		ifTrue:[^self] "Same priority but I am innermost"
		ifFalse:[^nil]. "Other guy has higher priority than I"! !


!Morph methodsFor: 'events-processing' stamp: 'jmv 5/28/2011 00:37'!
handlerForMouseDown: anEvent
	"Return the (prospective) handler for a mouse down event. The handler is temporarily installed and can be used for morphs further down the hierarchy to negotiate whether the inner or the outer morph should finally handle the event"
	anEvent mouseButton3Pressed ifTrue:[^self handlerForMouseButton3Down: anEvent].
	(self handlesMouseDown: anEvent) ifFalse:[^nil]. "not interested"
	anEvent handler ifNil:[^self]. "Nobody else was interested"
	self mouseDownPriority >= anEvent handler mouseDownPriority 
		ifTrue:[^self] "Same priority but I am innermost"
		ifFalse:[^nil]. "Other guy has higher priority than I"! !


!MouseEvent methodsFor: 'button state' stamp: 'jmv 5/30/2011 08:31'!
mouseButton1Pressed
	"Answer true if the mouseButton1 is being pressed.
	This is the first mouse button, usually the one at the left."

	"The Mac VM converts command-button1 to command-button3.
	If the preference is not set, convert this back to command-button1.
	In this way, it is the image and not the VM who's on control of the meaning of command-button1.
	(This logic is repeated in #mouseButton1Pressed, #mouseButton3Pressed, #mouseButton1Changed, #mouseButton3Changed."
	(self commandAltKeyPressed
		and: [ Preferences commandClickOpensHalo not
			and: [ Smalltalk platformName = 'Mac OS' ]])
		ifTrue: [ ^ buttons anyMask: InputSensor mouseButton3 ].
	^ buttons anyMask: InputSensor mouseButton1! !

!MouseEvent methodsFor: 'button state' stamp: 'jmv 5/30/2011 08:31'!
mouseButton3Pressed
	"Answer true if the mouseButton3 is being pressed.
	This is usually the center (wheel) mouse button or cmd+click on the Mac."

	"The Mac VM converts command-button1 to command-button3.
	If the preference is not set, convert this back to command-button1.
	In this way, it is the image and not the VM who's on control of the meaning of command-button1.
	(This logic is repeated in #mouseButton1Pressed, #mouseButton3Pressed, #mouseButton1Changed, #mouseButton3Changed."
	(self commandAltKeyPressed
		and: [ Preferences commandClickOpensHalo not
			and: [ Smalltalk platformName = 'Mac OS' ]])
		ifTrue: [ ^false ].
	^ buttons anyMask: InputSensor mouseButton3! !


!MouseButtonEvent methodsFor: 'accessing' stamp: 'jmv 5/30/2011 08:32'!
mouseButton1Changed
	"Answer true if the mouseButton1 has changed.
	This is usually the left mouse button."

	"The Mac VM converts command-button1 to command-button3.
	If the preference is not set, convert this back to command-button1.
	In this way, it is the image and not the VM who's on control of the meaning of command-button1.
	(This logic is repeated in #mouseButton1Pressed, #mouseButton3Pressed, #mouseButton1Changed, #mouseButton3Changed."
	
	(self commandAltKeyPressed
		and: [ Preferences commandClickOpensHalo not
			and: [ Smalltalk platformName = 'Mac OS' ]])
		ifTrue: [ ^ whichButton anyMask: InputSensor mouseButton3 ].
	^ whichButton anyMask: InputSensor mouseButton1! !

!MouseButtonEvent methodsFor: 'accessing' stamp: 'jmv 5/30/2011 08:32'!
mouseButton3Changed
	"Answer true if the mouseButton3 has changed.
	This is usually the center (wheel) mouse button or cmd+click on the Mac."

	"The Mac VM converts command-button1 to command-button3.
	If the preference is not set, convert this back to command-button1.
	In this way, it is the image and not the VM who's on control of the meaning of command-button1.
	(This logic is repeated in #mouseButton1Pressed, #mouseButton3Pressed, #mouseButton1Changed, #mouseButton3Changed."

	(self commandAltKeyPressed
		and: [ Preferences commandClickOpensHalo not
			and: [ Smalltalk platformName = 'Mac OS' ]])
		ifTrue: [ ^false ].
	^ whichButton anyMask: InputSensor mouseButton3! !


!Preferences class methodsFor: 'standard queries' stamp: 'jmv 5/30/2011 08:33'!
commandClickOpensHalo
	"
	Preferences enable: #commandClickOpensHalo
	Preferences disable: #commandClickOpensHalo
	"
	^ self
		valueOfFlag: #commandClickOpensHalo
		ifAbsent: [ true ].! !

Morph removeSelector: #handlerForMetaMenu:!
